VERSION 5.00
Object = "{7F5E3516-F816-11D0-B64C-00001C1AD1F8}#6.0#0"; "DWSBC36.OCX"
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin DWSBC36Lib.SubClass sbcChat 
      Left            =   2100
      Top             =   1350
      Messages        =   "frmMain.frx":0000
      CtlParam        =   ""
      RegMessage1     =   ""
      RegMessage2     =   ""
      RegMessage3     =   ""
      RegMessage4     =   ""
      RegMessage5     =   ""
      Persist         =   0   'False
      Type            =   0
      PostOnFreeze    =   0   'False
      PostOnFreezeMax =   20
      CrossTaskTimeout=   5000
      UseOnlyXEvent   =   0   'False
      UseDirectInterface=   0   'False
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'********************************************************************************
'* Component:       frmMain
'* Description:     Example of subclassing AOL chat room for the Enter key
'*                  or Send button being pressed/clicked.
'* Author:          Craig Jasper, Jr.
'* Machine:         CRAIG [ID: 4850] | Windows 2000 Server (SP2)
'* Modified:        7/14/2001
'* Dependencies:    DWSBC36.OCX (Licensed version ONLY.)
'********************************************************************************

' OVERVIEW
' I made this example because I'm sick of seeing
' these ccoms that send the commands to the chat
' room telling everyone what the program is doing.

' This will allow the command to be performed
' without allowing the text to be sent to the room.

' Among the benefits of this is that you don't have to constantly
' get the text from the chat room and check it to
' see if the screenname was the user and the text
' was a command string.

' The user will still enter the command the same
' way, but the text will not be sent to the room
' if it is a command string.

' This is also more efficient then using a chat
' scan or getting the last line of text via
' a timer.

' This was only tested with the following:
'    * Windows 2000 Server (Service Pack 2)
'    * SpyWorks 6.2 Subclassing Control (DWSBC36.OCX)
'    * AOL 6.0 Revision 4097.10523

' This assumes that you are already in a chat room.
' If you start this project with AOL running and are
' not in a chat room this may subclass the incorrect
' AOLIcon and/or RICHCNTL depending on what windows are
' open. If you use this code in a program that is put into
' production write a routine to make sure the correct
' handles are being Subclassed.

' This code has room for improvement which I
' will leave up to you...

' See ya,

' -Craig

Option Explicit

Private Const WM_CHAR = &H102
Private Const WM_DESTROY = &H2
Private Const WM_LBUTTONDOWN = &H201

'********************************************************************************
' Routine:        Form_KeyPress
'********************************************************************************
Private Sub Form_KeyPress(KeyAscii As Integer)
    On Error GoTo PROC_ERR
    
    ' This was added because I get sick of clicking
    ' the X or pressing Alt + F4 while debugging. I
    ' rather press Esc...
    
    If KeyAscii = vbKeyEscape Then
        Unload Me
    End If
    
    Exit Sub
PROC_ERR:
    MsgBox "Error: " & Err.Description & vbCrLf & "Routine: Form_KeyPress", vbCritical
End Sub

'********************************************************************************
' Routine:        Form_Load
'********************************************************************************
Private Sub Form_Load()
    On Error GoTo PROC_ERR
                
    With Me
        ' The only reason AutoRedraw is set to true
        ' is because this prints to this form in the
        ' sbcChat_WndMessageX event...
        .AutoRedraw = True
        .KeyPreview = True
        .Move 0, 0, 9000, 1000
        Call SetTopMostWindow(.hWnd)
    End With
    
    ' Don't try to subclass a handle that is 0...
    If AOLIcon <> 0 Then
        
        With sbcChat
            .AddHwnd = (AOLIcon)
            .AddHwnd = (RICHCNTL)
            .Messages = (WM_CHAR)
            .Messages = (WM_DESTROY)
            .Messages = (WM_LBUTTONDOWN)
            
            ' sbcPreDefault is the default, so this
            ' line below can be omitted. Remember to
            ' NEVER use DoEvents or display a MsgBox
            ' during a non-posted message.
             .Type = sbcPreDefault
        End With
    
    Else
        MsgBox "AOLIcon = 0. Bye.", vbCritical
        Unload Me
    End If
    
    Exit Sub
PROC_ERR:
    MsgBox "Error: " & Err.Description & vbCrLf & "Routine: Form_Load", vbCritical
    Unload Me
End Sub

'********************************************************************************
' Routine:        Form_Unload
'********************************************************************************
Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo PROC_ERR
    
    '*****************************************
    '* DO NOT OMIT THIS CODE OR VB MAY CRASH.*
    '*****************************************
    
    ' Why set the HwndParam to 0 if it is already 0?
    ' Check first so your not running code that is
    ' doing nothing that is already done...
    If sbcChat.HwndParam <> 0 Then
        ' Make sure to set the HwndParam to 0 when
        ' unloading or VB may crash, especially under
        ' Windows 95/98.
        sbcChat.HwndParam = 0
    End If
    
    Set frmMain = Nothing   ' Final clean-up.
    
    Exit Sub
PROC_ERR:
    MsgBox "Error: " & Err.Description & vbCrLf & "Routine: Form_Unload", vbCritical
End Sub

'********************************************************************************
' Routine:        sbcChat_WndMessageX
' Description:    See your SpyWorks help file for description.
'********************************************************************************
Private Sub sbcChat_WndMessageX _
       (wnd As Long, _
       msg As Long, _
       wp As Long, _
       lp As Long, _
       retval As Long, _
       nodef As Integer, _
       process As Long)
    
    On Error GoTo PROC_ERR
    
    Select Case msg
        Case WM_CHAR And wp = vbKeyReturn, WM_LBUTTONDOWN And wnd = AOLIcon
            If LCase$(GetText(RICHCNTL)) = LCase$("Wanted String") Then
                nodef = True    ' Stop default processing.
                Call ClearText
                
                ' TODO: Add your routine here...
                
                Me.Cls
                Me.Print "frmMain sbcChat_WndMessageX: WM_CHAR (vbKeyReturn) or WM_LBUTTONDOWN: " & Now
            End If
            
        Case WM_DESTROY
            ' Stop trying to Subclass a handle that
            ' no longer exists:
            sbcChat.HwndParam = 0
            
            Me.Cls
            Me.Print "WM_DESTROY: No longer subclassing. " & Now
    End Select
    
    Exit Sub
PROC_ERR:
    MsgBox "Error: " & Err.Description & vbCrLf & "Routine: sbcChat_WndMessageX", vbCritical
End Sub
